﻿/** *********************softkeyboard******************************* */

// var KEY_OK = 13;
// var KEY_UP = 38;
// var KEY_DOWN = 40;
// var KEY_LEFT = 37;
// var KEY_RIGHT = 39;
// var KEY_RED = 112;
// var KEY_GREEN = 113;
// var KEY_YELLOW = 114;
// var KEY_BLUE = 115;
// var KEY_WHITE = 118;
// var KEY_DELETE = 8;
// var KEY_EXIT = 27;
// var KEY_TV = 33;
// var KEY_RECALL = 34;
// var KEY_FAV = 119;
// var KEY_SHIFT = 83;
// var KEY_CTRL = 0;
// var KEY_CAPSLOCK = 0;
// var KEY_TAB = 9;
// var KEY_ALT = 0;
// var KEY_PAGEUP = 33;
// var KEY_PAGEDOWN = 34;
// var KEY_DEL = 46;
// var KEY_END = 35;
// var KEY_INSERT = 45;
// var KEY_F5 = 116;
// var KEY_F6 = 117;
// var KEY_F7 = 0;
// var KEY_F10 = 121;
// var KEY_F11 = 122;
// var KEY_F12 = 123;
// var KEY_S1 = 63;
// var KEY_HOME = 0;
// var KEY_CTRLESC = 0;
// var KEY_ALRHOME = 0;
// var KEY_TV = 0;
// var KEY_TVSAT = 0;
// var KEY_SAT = 0;
// var KEY_RECORD = 0;
// var KEY_STOP = 0;
// var KEY_KONG = 32;
// var KEY_NUMLOCK = 0;
// var KEY_NUMBIAS = 0;
// var KEY_NUMMUL = 0;
// var KEY_NUMSUB = 0;
// var KEY_NUMADD = 0;
// var KEY_NUMDEL = 0;
var KEY_CAPSLOCK = 57424;
var KEY_INSERT = 4;
var KEY_ALRHOME = 5;
var KEY_END = 6;
var KEY_PAGEUP = 7;
var KEY_PAGEDOWN = 8;
var KEY_STOP = 10;
var KEY_EXIT = 27;
var KEY_WHITE = 57349;
var KEY_S1 = 63;
var KEY_RED = 57345;
var KEY_GREEN = 57346;
var KEY_YELLOW = 57347;
var KEY_BLUE = 57348;
var KEY_F5 = 57425;
var KEY_F6 = 57350;
var KEY_F7 = 57351;
var KEY_FAV = 57352;
var KEY_RECALL = 57353;
var KEY_F10 = 57354;
var KEY_F11 = 57355;
var KEY_F12 = 57356;
var KEY_UP = 57385;
var KEY_DOWN = 57386;
var KEY_LEFT = 57387;
var KEY_RIGHT = 57388;
var KEY_CTRLESC = 57389;
var KEY_DEL = 57395;
var KEY_DELETE = 57396;
var KEY_TAB = 57397;
var KEY_OK = 57399;
var KEY_ALT = 57400;
var KEY_SHIFT = 57401;
var KEY_CTRL = 57402;
var KEY_TVSAT = 61709;
var KEY_TV = 61717;
var KEY_RECORD = 61720;
var KEY_HOME = 61984;
var KEY_SAT = 62721;
var KEY_KONG = 57398;

var KEY_NUMLOCK = 57425;
var KEY_NUMBIAS = 57390;
var KEY_NUMMUL = 57391;
var KEY_NUMSUB = 57393;
var KEY_NUMADD = 57392;
var KEY_NUMDEL = 127;

function keypress_cb(code) {
	console.log(code + "---------------------");
	window.softkeyboard.keypress(code);
}

(function() {
	var isInsert = true;
	var maxLen = 0;
	var passWord = "";
	var cursorIndex = 0;
	var isPassWord = true;
	var isSquareKeyboard = false;
	var capslock = false;
	var isSelectLang = false;
	if (localStorage.capslock) {
		if (localStorage.capslock == "true") {
			capslock = true;
		} else if (localStorage.capslock == "false") {
			capslock = false;
		}

	} else {
		capslock = false;
	}
	if (localStorage.isSquareKeyboard) {
		if (localStorage.isSquareKeyboard == "true") {
			isSquareKeyboard = true;
		} else if (localStorage.isSquareKeyboard == "false") {
			isSquareKeyboard = false;
		}

	} else {
		isSquareKeyboard = false;
	}
	var lang = "eng";
	if (localStorage.lang) {
		lang = localStorage.lang;
	} else {
		lang = "eng";
	}
	var $softkeyboardobj = jQuery("#softkeyboard"), $squareKey = $softkeyboardobj
			.find(".squareKeyboard"), $squaraCapsObj = $squareKey
			.find("li span[class^='val" + lang + "']"), $normalKey = $softkeyboardobj
			.find(".normalKeyboard"), $langSelectObj = $softkeyboardobj
			.find(".langselect"), $write = jQuery('.write'), cursorBefore = $write
			.find(".cursorBefore"), cursor = $write.find(".cursor"), cursorAfter = $write
			.find(".cursorAfter"), moveDiv = $write.find(".moveDiv"), $lang = $softkeyboardobj
			.find(".top .lang");
	var $arali = $langSelectObj.find(".ara_lang"), $hebli = $langSelectObj
			.find(".heb_lang"), $hunli = $langSelectObj.find(".hun_lang"), $engli = $langSelectObj
			.find(".eng_lang");
	var $normalUps, $normalLowers;
	var $this;
	var $softkeyboardContent;
	var $whiteKey = jQuery("#whiteKey");
	var redBtnDiv = $softkeyboardobj.find(".down .colorKey .redDiv"), greenBtnDiv = $softkeyboardobj
			.find(".down .colorKey .greenDiv"), yellowBtnDiv = $softkeyboardobj
			.find(".down .colorKey .yellowDiv"), blueBtnDiv = $softkeyboardobj
			.find(".down .colorKey .blueDiv"), whiteBtnDiv = $softkeyboardobj
			.find(".down .colorKey .whiteDiv");
	var prePress, pressNumber = 1, clearTimer = 0, beforeMoveSize = 0, cursorFlag = false, beforWidth, cursorWidth, afterWidth, windowWidth, showWidth, beforeWord, afterWord, wordLength = 0, cursorTimer = 0;
	setImeOptions = function(text, multiline, password, maxlen) {
		if (multiline) {
			maxlen = 999999;
		}
		isSelectLang = false;
		$langSelectObj.hide();
		isPassWord = password;
		var len = text.length;
		if (len >= maxlen) {
			isInsert = false;
		}else {
			isInsert = true;
		}
		//console.log("text" +text+ " len=="+len+" maxlen=="+maxlen+" isInsert=="+isInsert);
		maxLen = maxlen;

		wordLength = len;
		var nowword;
		if (isPassWord) {
			cursorIndex = len;
			passWord = text;
			nowword = softkeyboard.insertSign(len);

		} else {
			nowword = text;
		}
		// console.log(nowword+"--------------------");
		if (lang == "ara" || lang == "heb") {
			cursorBefore.html("");
			cursorAfter.html(nowword);
		} else {
			cursorBefore.html(nowword);
			cursorAfter.html("");
		}
		// console.log("init word-------------------------");
		beforWidth = cursorBefore.outerWidth();
		cursorWidth = cursor.outerWidth();
		afterWidth = cursorAfter.outerWidth();
		windowWidth = $write.innerWidth();
		showWidth = beforWidth + cursorWidth + afterWidth;
		beforeWord = cursorBefore.text();
		afterWord = cursorAfter.text();
		clearInterval(cursorTimer);
		cursorTimer = setInterval("softkeyboard.showCursor()", 1000);
		$lang.text(softkeyboardHandler.Language(lang));
		$this = jQuery('.focused');
		$this.removeClass("focused");
		if (!isSquareKeyboard) {
			softkeyboardHandler.normalKeyInit();
		} else {
			softkeyboardHandler.squareKeyInit();
		}
		if (moveDiv.css("left") != "0px") {
			moveDiv.css("left", 0);
		}
		$softkeyboardobj.show();
		//softkeyboardHandler.init();
	}
	var softkeyboardHandler = window.softkeyboard = {};

			softkeyboardHandler.keypress = function(code) {

				if (isSquareKeyboard) {
					softkeyboardHandler.squareKeySwitch(code);
				} else {

					softkeyboardHandler.normalKeySwitch(code);

				}
			},

			softkeyboardHandler.init = function() {

				jQuery(document).keypress(function(event) {
					if (isSquareKeyboard) {
						softkeyboardHandler.squareKeySwitch(event.keyCode);
					} else {
						softkeyboardHandler.normalKeySwitch(event.keyCode);

					}

				});

			},
			softkeyboardHandler.squareKeyPress = function(character) {
				if (isSquareKeyboard) {
					var patrn = /[^\d]/g;
					if (!patrn.exec(character)) {
						$this.removeClass('focused');
						$this = $squareKey.find('.key' + character);
						$this.addClass('focused');

						if (prePress != character) {

							prePress = character;
							character = $squareKey.find(
									".val" + lang + character).attr("p1");
							if (capslock) {
								character = character.toLocaleUpperCase();
							}
							softkeyboardHandler.insertCharacters(character);
						} else {

							if (!isInsert) {
								return false;
							}
							var pNumber = $squareKey.find(
									".val" + lang + character).attr("pNumber");
							if (++pressNumber > pNumber)
								pressNumber = 1;
							character = $squareKey.find(
									".val" + lang + character).attr(
									"p" + pressNumber);
							if (capslock) {
								character = character.toLocaleUpperCase();
							}
							if (isPassWord) {
								var str = passWord
										.substring(0, cursorIndex - 1)
										+ character
										+ passWord.substring(cursorIndex,
												passWord.length);
								passWord = str;
								beforeWord = beforeWord.substring(0,
										beforeWord.length - 1)
										+ "*";
							} else {
								beforeWord = beforeWord.substring(0,
										beforeWord.length - 1)
										+ character;

							}
							// console.log(passWord);
							cursorBefore.text(beforeWord);

							clearInterval(clearTimer);
							clearTimer = setInterval(
									"softkeyboard.chanageSquareKeyPress()",
									1000);

						}

					} else if (character == "Del") {
						softkeyboardHandler.deleteCharacters();
					} else if (character.toLocaleLowerCase() == "abc") {
						capslock = !capslock;
						if (isSquareKeyboard) {
							softkeyboardHandler.squareKeyCaps();
						} else {
							$softkeyboardobj.find(
									"ul li span[class='" + !capslock + "']")
									.hide();
							$softkeyboardobj.find(
									"ul li span[class='" + capslock + "']")
									.show();
						}

						localStorage.capslock = capslock;
					}
				}
			},
			softkeyboardHandler.insertCharacter = function($this) {

				var character = $this.find("span[class!='" + !capslock + "']")
						.html();

				if ($this.hasClass('keysignspace')) {
					character = " ";
				} else if ($this.hasClass('lt')) {
					character = "<";
				} else if ($this.hasClass('and')) {
					character = "&";
				} else if ($this.hasClass('gt')) {
					character = ">";
				} else if ($this.hasClass('keydel')) {
					// Delete
					// cursorBefore.deleteAtCaret();
					softkeyboardHandler.deleteCharacters();
					return false;
				} else if ($this.hasClass('keycaps')) {
					// Uppercase letter
					capslock = !capslock;
					if (isSquareKeyboard) {
						softkeyboardHandler.squareKeyCaps();
					} else {

						if (!capslock) {
							$softkeyboardContent.find(".keycaps").removeClass(
									"caps");
							$normalUps.hide();
							$normalLowers.show();
						} else {
							$softkeyboardContent.find(".keycaps").addClass(
									"caps");
							$normalLowers.hide();
							$normalUps.show();
						}

					}
					character = "";
					localStorage.capslock = capslock;
					return false;

				} else if ($this.hasClass('keyclear')) {
					// Special characters
					cursorBefore.html("");
					cursorAfter.html("");
					beforeWord = "";
					afterWord = "";
					moveDiv.css("left", 0);
					wordLength = 0;
					passWord = "";
					isInsert = true;
					return false;
				} else if ($this.hasClass('keyenter')) {

					var text = "";
					if (isPassWord) {
						text = passWord;
						// console.log(passWord);
					} else {
						if (lang == "ara" || lang == "heb") {
							text = cursorAfter.text() + cursorBefore.text();
						} else {
							text = cursorBefore.text() + cursorAfter.text();
						}
					}
					if (text == "") {
						opera.sendPlatformMessage("key://" + "clear");

					} else {
						opera.sendPlatformMessage("str://" + text);
					}

					opera.sendPlatformMessage("key://" + "enter");

					$this.removeClass('focused');
					character = "\n";
					return false;

				}
				softkeyboardHandler.insertCharacters(character);

			},
			softkeyboardHandler.chanageSquareKeyPress = function() {

				prePress = -1;
				pressNumber = 1;
			},
			softkeyboardHandler.showCursor = function() {

				if (cursorFlag) {
					cursor.css("visibility", "visible");
				} else {
					cursor.css("visibility", "hidden");
				}
				cursorFlag = !cursorFlag;
			},
			softkeyboardHandler.insertSign = function(n) {

				var str = "";
				for (i = 0; i < n; i++) {
					str = str + "*";
				}
				return str;
			},
			softkeyboardHandler.insertCharacters = function(myValue) {

				if (!isInsert) {
					return false;
				}
				if (lang == "ara" || lang == "heb") {
					if (isPassWord) {

						var len = passWord.length;
						var str = passWord.substring(0, len - cursorIndex)
								+ myValue
								+ passWord.substring(len - cursorIndex, len);
						var wordlen = myValue.length;
						passWord = str;

						afterWord = afterWord
								+ window.softkeyboard.insertSign(wordlen);
					} else {

						afterWord = afterWord + myValue;
					}
					cursorAfter.text(afterWord);
					wordLength = wordLength + myValue.length;
					if (wordLength >= maxLen) {
						isInsert = false;
					}

					// cursorBefore.text(beforeWord);

				} else {
					if (isPassWord) {
						var str = passWord.substring(0, cursorIndex)
								+ myValue
								+ passWord.substring(cursorIndex,
										passWord.length);
						passWord = str;
						// console.log(passWord);
						var len = myValue.length;
						cursorIndex = cursorIndex + len;
						beforeWord = cursorBefore.text()
								+ window.softkeyboard.insertSign(len);
					} else {

						beforeWord = cursorBefore.text() + myValue;
					}

					wordLength = wordLength + myValue.length;

					if (wordLength >= maxLen) {
						isInsert = false;
					}

					cursorBefore.text(beforeWord);
					beforWidth = cursorBefore.outerWidth();

					showWidth = beforWidth + 2 * cursorWidth;
					if (showWidth > windowWidth) {
						var left = showWidth - windowWidth + 2 * cursorWidth;
						moveDiv.css("left", -left);
					}
				}

			},
			softkeyboardHandler.deleteCharacters = function() {
				var len = 0;
				if (lang == "ara" || lang == "heb") {
					len = afterWord.length;
					if (len > 0) {
						if (isPassWord) {

							var len = passWord.length;
							var str = passWord.substring(0, len - cursorIndex
									- 1)
									+ passWord
											.substring(len - cursorIndex, len);
							passWord = str;

						}
						afterWord = afterWord.substring(0, len - 1);
						cursorAfter.text(afterWord);
						wordLength = wordLength - 1;
						if (!isInsert) {
							if (wordLength < maxLen) {
								isInsert = true;
							}
						}
					} else if (len == 0) {
						var beforelen = beforeWord.length;
						if (beforelen > 0) {
							if (isPassWord) {

								var len = passWord.length;
								var str = passWord.substring(0, len
										- cursorIndex - 1)
										+ passWord.substring(len - cursorIndex,
												len);
								passWord = str;

							}
							beforeWord = beforeWord.substring(0, beforelen - 1);
							cursorBefore.text(beforeWord);
							wordLength = wordLength - 1;
							if (!isInsert) {
								if (wordLength < maxLen) {
									isInsert = true;
								}
							}
						}
					}

				} else {
					len = beforeWord.length;
					if (len > 0) {

						if (isPassWord) {
							cursorIndex--;
							var str = passWord.substring(0, cursorIndex)
									+ passWord.substring(cursorIndex + 1,
											passWord.length);
							passWord = str;

						}
						beforeMoveSize = cursorBefore.outerWidth();
						var str = beforeWord.substring(0, len - 1);

						beforeWord = str;
						cursorBefore.html(beforeWord);
						wordLength = wordLength - 1;
						beforWidth = cursorBefore.outerWidth();

						showWidth = beforWidth + 2 * cursorWidth;
						if (showWidth >= windowWidth) {
							var left = parseInt(moveDiv.css("left").replace(
									"px", ""))
									- (beforWidth - beforeMoveSize);

							moveDiv.css("left", left);
						} else {
							if (moveDiv.css("left") != "0px") {
								moveDiv.css("left", "0");
							}
						}

						if (!isInsert) {
							if (wordLength < maxLen) {
								isInsert = true;
							}
						}

					}
				}

			},
			softkeyboardHandler.squareKeyCaps = function() {
				if (capslock) {
					$squaraCapsObj.each(function() {
						var str = jQuery(this).text().toLocaleUpperCase();
						jQuery(this).text(str);
					});
					$squareKey.find(".keycaps").text("ABC");
				} else {
					$squaraCapsObj.each(function() {
						var str = jQuery(this).text().toLocaleLowerCase();
						jQuery(this).text(str);
					});
					$squareKey.find(".keycaps").text("abc");
				}
			},
			softkeyboardHandler.squareKeyInit = function() {
				$normalKey.hide();
				$softkeyboardContent = $squareKey.find("ul");
				$squaraCapsObj = $squareKey.find("span[class^='val" + lang
						+ "']");
				softkeyboardHandler.squareKeyCaps();
				$squaraCapsObj.show();
				$this = $softkeyboardContent.find(".key0");
				$this.addClass('focused');
				$squareKey.show();
				$arali.hide();
				$hebli.hide();
				$hunli.attr("dx", "eng_lang");
				$engli.attr("ux", "hun_lang");
				$langSelectObj.css("height", 190);
			},
			softkeyboardHandler.normalKeyInit = function() {

				$squareKey.hide();
				$softkeyboardContent = $softkeyboardobj.find("ul[class='"
						+ lang + "']");
				$normalUps = $softkeyboardContent.find("li span[class='true']");
				$normalLowers = $softkeyboardContent
						.find("li span[class='false']");
				if (!capslock) {

					$normalUps.hide();
					$normalLowers.show();
				} else {
					$normalLowers.hide();
					$normalUps.show();
					$softkeyboardContent.find(".keycaps").addClass("caps");
				}

				$this = $softkeyboardContent.find(".key0");
				// console.log($this.parent().html());
				$this.addClass('focused');
				softkeyboardHandler.ChanageAraClass();
				$softkeyboardContent.show();
				$normalKey.show();
				$arali.show();
				$hebli.show();
				$hunli.attr("dx", "ara_lang");
				$engli.attr("ux", "heb_lang");
				$langSelectObj.css("height", 260);

			},
			softkeyboardHandler.normalKeySwitch = function(code) {
				$this = $('.focused');

				switch (code) {
				case KEY_SHIFT:
				case KEY_CTRL:
				case KEY_CAPSLOCK:
				case KEY_TAB:
				case KEY_ALT:
				case KEY_PAGEUP:
				case KEY_PAGEDOWN:
				case KEY_DEL:
				case KEY_END:
				case KEY_INSERT:
				case KEY_F5:
				case KEY_F6:
				case KEY_F7:
				case KEY_F10:

				case KEY_F12:
				case KEY_S1:
				case KEY_HOME:
				case KEY_CTRLESC:
				case KEY_ALRHOME:
				case KEY_TV:
				case KEY_TVSAT:
				case KEY_SAT:
				case KEY_RECORD:
				case KEY_STOP:
				case KEY_NUMLOCK:
				case KEY_NUMBIAS:
				case KEY_NUMMUL:
				case KEY_NUMSUB:
				case KEY_NUMADD:
				case KEY_NUMDEL: {

					break;
				}
				case KEY_OK: {
					if ($this.hasClass('lang')) {
						isSelectLang = true;
						$langSelectObj.show();
						$this.removeClass("focused");
						$this = jQuery(".langselect li[class='" + lang
								+ "_lang']");
						$this.addClass("focused");

					} else if ($this.attr("class").indexOf("_lang") > -1) {
						lang = $this.attr("lang");
						softkeyboardHandler.ChanageAraClass();
						if (lang == "ara" || lang == "heb") {

							$whiteKey.hide();
							// cursorBefore.css("direction", "rtl");

						} else {

							if ($whiteKey.is(":hidden")) {
								$whiteKey.show();
							}
						}
						$this.removeClass("focused");
						$langSelectObj.hide();

						$this = $softkeyboardobj.find(".top .lang");
						$this.addClass("focused");
						$this.text(softkeyboardHandler.Language(lang));
						$softkeyboardContent.hide();
						$softkeyboardContent = $softkeyboardobj
								.find("ul[class='" + lang + "']");
						$normalUps = $softkeyboardContent
								.find("li span[class='true']");
						$normalLowers = $softkeyboardContent
								.find("li span[class='false']");
						if (capslock) {
							$softkeyboardContent.find(".keycaps").addClass(
									"caps");
							$normalLowers.hide();
							$normalUps.show();

						} else {
							$softkeyboardContent.find(".keycaps").removeClass(
									"caps");
							$normalUps.hide();
							$normalLowers.show();
						}
						$softkeyboardContent.show();
						$squaraCapsObj.hide();
						localStorage.lang = lang;
						$squaraCapsObj = $squareKey.find("li span[class^='val"
								+ lang + "']");
						// .show();
						isSelectLang = false;

					} else {
						beforeWord = cursorBefore.text();
						softkeyboardHandler.insertCharacter($this);

					}

					break;
				}
				case KEY_FAV: {
					isSelectLang = true;
					$langSelectObj.show();
					$this.removeClass("focused");
					$this = jQuery(".langselect li[class='" + lang + "_lang']");
					$this.addClass("focused");
					break;
				}
				case KEY_UP: {
					var keyId = '.' + $this.attr('ux');
					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {

							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');

						}
					}

					break;
				}
				case KEY_DOWN: {
					var keyId = '.' + $this.attr('dx');

					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');

							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');
						}
					}

					break;
				}
				case KEY_LEFT: {
					if (isSelectLang) {
						return false;
					}
					var keyId = '.' + $this.attr('lx');

					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');
						}
					}

					break;
				}
				case KEY_RIGHT: {

					if (isSelectLang) {
						return false;
					}
					var keyId = '.' + $this.attr('rx');

					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {

							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');
						}
					}

					break;
				}
				case KEY_DELETE: {
					if (isSelectLang) {
						return false;
					}

					softkeyboardHandler.deleteCharacters();

					break;

				}
				case KEY_RED: {
					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					var text = "";
					if (isPassWord) {
						text = passWord;
					} else {
						if (lang == "ara" || lang == "heb") {
							text = cursorAfter.text() + cursorBefore.text();
						} else {
							text = cursorBefore.text() + cursorAfter.text();
						}

					}
					if (text == "") {
						opera.sendPlatformMessage("key://" + "clear");

					} else {
						opera.sendPlatformMessage("str://" + text);
					}
					opera.sendPlatformMessage("key://" + "enter");
					break;
				}
				case KEY_GREEN: {
					if (isSelectLang) {
						return false;
					}
					var len;
					var strBefore;
					var strAfter;
					if (lang == "ara" || lang == "heb") {
						len = afterWord.length;
						if (len > 0) {
							cursorIndex++;
							beforeMoveSize = cursorBefore.outerWidth();
							strBefore = afterWord.substring(len - 1, len)
									+ beforeWord;
							strAfter = afterWord.substring(0, len - 1);
							beforeWord = strBefore;
							afterWord = strAfter;
							cursorBefore.text(strBefore);
							cursorAfter.text(strAfter);
							beforWidth = cursorBefore.outerWidth();
							afterWidth = cursorAfter.outerWidth();
							showWidth = windowWidth
									- (beforWidth + parseInt(moveDiv
											.css("left").replace("px", "")))
									- 2 * cursorWidth;
							if (showWidth < 0) {
								var left = parseInt(moveDiv.css("left")
										.replace("px", ""))
										- (beforWidth - beforeMoveSize);
								moveDiv.css("left", left);

							}
						}
					} else {
						// console.log("gren-----------");
						len = beforeWord.length;
						if (len > 0) {
							cursorIndex--;
							beforeMoveSize = cursorAfter.outerWidth();
							strBefore = beforeWord.substring(0,
									beforeWord.length - 1);
							strAfter = beforeWord.substring(
									beforeWord.length - 1, beforeWord.length)
									+ cursorAfter.text();
							beforeWord = strBefore;
							afterWord = strAfter;
							cursorBefore.text(strBefore);
							cursorAfter.text(strAfter);
							beforWidth = cursorBefore.outerWidth();
							afterWidth = cursorAfter.outerWidth();
							showWidth = beforWidth
									+ parseInt(moveDiv.css("left").replace(
											"px", "")) + cursorWidth;

							if (showWidth < 0) {
								// alert("ok");
								var left = parseInt(moveDiv.css("left")
										.replace("px", ""))
										+ afterWidth - beforeMoveSize;
								moveDiv.css("left", left);

							}

							// console.log("strBefore :"+strBefore+"strAfter
							// "+strAfter);

						}
					}

					break;
				}
				case KEY_YELLOW: {
					if (isSelectLang) {
						return false;
					}
					var strBefore;
					var strAfter;
					var len;

					if (lang == "ara" || lang == "heb") {
						len = beforeWord.length;
						if (len > 0) {
							cursorIndex--;
							strBefore = beforeWord.substring(1, len);
							strAfter = afterWord + beforeWord.substring(0, 1);

							beforeMoveSize = cursorAfter.outerWidth();
							beforeWord = strBefore;
							afterWord = strAfter;
							cursorBefore.text(strBefore);
							cursorAfter.text(strAfter);
							beforWidth = cursorBefore.outerWidth();
							afterWidth = cursorAfter.outerWidth();
							showWidth = beforWidth
									+ parseInt(moveDiv.css("left").replace(
											"px", "")) + cursorWidth;
							if (showWidth < 0) {
								// alert("ok");
								var left = parseInt(moveDiv.css("left")
										.replace("px", ""))
										+ afterWidth - beforeMoveSize;
								moveDiv.css("left", left);

							}
						}

					} else {
						len = afterWord.length;
						if (len > 0) {
							cursorIndex++;
							beforeMoveSize = cursorBefore.outerWidth();
							strBefore = beforeWord + afterWord.substring(0, 1);

							strAfter = afterWord.substring(1, afterWord.length);
							// console.log("strBefore: " + strBefore + "
							// strAfter: " + strAfter);
							beforeWord = strBefore;
							afterWord = strAfter;
							cursorBefore.text(strBefore);
							cursorAfter.text(strAfter);
							beforWidth = cursorBefore.outerWidth();
							afterWidth = cursorAfter.outerWidth();

							showWidth = windowWidth
									- (beforWidth + parseInt(moveDiv
											.css("left").replace("px", "")))
									- cursorWidth;

							if (showWidth < 0) {
								var left = parseInt(moveDiv.css("left")
										.replace("px", ""))
										- (beforWidth - beforeMoveSize);

								moveDiv.css("left", left);

							}
						}

					}

					break;
				}
				case KEY_BLUE: {
					if (isSelectLang) {
						return false;
					}
					if (lang == "ara" || lang == "heb") {
						return false;
					}
					isSquareKeyboard = !isSquareKeyboard;
					$this.removeClass('focused');
					softkeyboardHandler.squareKeyInit();
					localStorage.isSquareKeyboard = isSquareKeyboard;
					break;
				}
				case KEY_EXIT: {

					break;
				}
				case KEY_WHITE:
				case KEY_F11: {

					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					cursorBefore.html("");
					cursorAfter.html("");
					beforeWord = "";
					afterWord = "";
					wordLength = 0;
					opera.sendPlatformMessage("key://" + "enter");
					wordLength = 0;
					break;
				}
				case KEY_RECALL: {
					if (isSelectLang) {
						return false;
					}

					softkeyboardHandler.deleteCharacters();

					break;
				}
				case KEY_KONG: {
					if (isSelectLang) {
						return false;
					}

					softkeyboardHandler.insertCharacters(" ");

					break;
				}

				default: {
					if (isSelectLang) {
						return false;
					}
					var character = String.fromCharCode(code);

					var patrn = /[^\d]/g;

					if (!patrn.exec(character)) {

						$this.removeClass('focused');
						$this = $softkeyboardContent.find('.key' + character);
						$this.addClass('focused');
						if (lang == "ara") {
							switch (character) {
							case "0":
								character = "٠";
								break;
							case "1":
								character = "١";
								break;
							case "2":
								character = "٢";
								break;
							case "3":
								character = "٣";
								break;
							case "4":
								character = "٤";
								break;
							case "5":
								character = "٥";
								break;

							case "6":
								character = "٦";
								break;
							case "7":
								character = "٧";
								break;
							case "8":
								character = "٨";
								break;
							case "9":
								character = "٩";
								break;
							default:
								break;
							}
						}
					}
					softkeyboardHandler.insertCharacters(character);

					break;
				}
				}

			},
			softkeyboardHandler.squareKeySwitch = function(code) {
				$this = jQuery('#softkeyboard .focused');
				switch (code) {
				case KEY_SHIFT:
				case KEY_CTRL:
				case KEY_CAPSLOCK:
				case KEY_TAB:
				case KEY_ALT:
				case KEY_PAGEUP:
				case KEY_PAGEDOWN:
				case KEY_DEL:
				case KEY_END:
				case KEY_INSERT:
				case KEY_F5:
				case KEY_F6:
				case KEY_F7:
				case KEY_F10:
				case KEY_F11:
				case KEY_F12:
				case KEY_S1:
				case KEY_HOME:
				case KEY_CTRLESC:
				case KEY_ALRHOME:
				case KEY_TVSAT:
				case KEY_SAT:
				case KEY_RECORD:
				case KEY_STOP:
				case KEY_NUMBIAS:
				case KEY_NUMMUL:
				case KEY_NUMSUB:
				case KEY_NUMADD:
				case KEY_NUMDEL: {

					break;
				}
				case KEY_OK: {

					if ($this.hasClass('lang')) {
						isSelectLang = true;
						$langSelectObj.show();
						$this.removeClass("focused");
						$this = jQuery(".langselect li[class='" + lang
								+ "_lang']");
						$this.addClass("focused");

					} else if ($this.attr("class").indexOf("_lang") > -1) {
						$squareKey.find("li span[class^='val" + lang + "']")
								.hide();

						cursor.css("visibility", "hidden");
						$softkeyboardobj.find("ul[class='" + lang + "']")
								.hide();
						lang = $this.attr("lang");
						// var str = $this.html();
						$squaraCapsObj = $squareKey.find("li span[class^='val"
								+ lang + "']");
						softkeyboardHandler.squareKeyCaps();
						$squaraCapsObj.show();

						localStorage.lang = lang;

						$this.removeClass("focused");
						$langSelectObj.hide();
						$this = $softkeyboardobj.find(".top .lang");
						$this.addClass("focused");
						$this.text(softkeyboardHandler.Language(lang));
						// $this.html(str);
						isSelectLang = false;

					} else {
						beforeWord = cursorBefore.text();
						if (isSquareKeyboard) {
							softkeyboardHandler.squareKeyPress($this.text());
						}

					}

					break;
				}
				case KEY_FAV: {
					isSelectLang = true;
					$langSelectObj.show();
					$this.removeClass("focused");
					$this = jQuery(".langselect li[class='" + lang + "_lang']");
					$this.addClass("focused");
					break;
				}
				case KEY_UP: {

					var keyId = '.' + $this.attr('ux');
					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {

							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');

						}
					}

					break;
				}
				case KEY_DOWN: {

					var keyId = '.' + $this.attr('dx');
					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');

							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');
						}
					}

					break;
				}
				case KEY_LEFT: {
					if (isSelectLang) {
						return false;
					}
					var keyId = '.' + $this.attr('lx');
					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');
							jQuery(keyId).addClass('focused');
						}
					}

					break;
				}
				case KEY_RIGHT: {
					if (isSelectLang) {
						return false;
					}
					var keyId = '.' + $this.attr('rx');

					if (keyId != '.') {
						if (keyId.indexOf("lang") < 0) {
							$this.removeClass('focused');
							$softkeyboardContent.find(keyId)
									.addClass('focused');
						} else {
							$this.removeClass('focused');

						}
					}

					break;
				}
				case KEY_DELETE: {
					if (isSelectLang) {
						return false;
					}

					softkeyboardHandler.deleteCharacters();

					break;

				}
				case KEY_RED: {
					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					var text = "";
					if (isPassWord) {
						text = passWord;
					} else {
						if (lang == "ara" || lang == "heb") {
							text = cursorAfter.text() + cursorBefore.text();
						} else {
							text = cursorBefore.text() + cursorAfter.text();
						}
					}
					if (text == "") {
						opera.sendPlatformMessage("key://" + "clear");

					} else {
						opera.sendPlatformMessage("str://" + text);
					}
					opera.sendPlatformMessage("key://" + "enter");
					break;
				}
				case KEY_GREEN: {
					if (isSelectLang) {
						return false;
					}
					if (beforeWord.length > 0) {
						cursorIndex--;
						beforeMoveSize = cursorAfter.outerWidth();
						var strBefore = beforeWord.substring(0,
								beforeWord.length - 1);
						var strAfter = beforeWord.substring(
								beforeWord.length - 1, beforeWord.length)
								+ cursorAfter.text();
						beforeWord = strBefore;
						afterWord = strAfter;
						cursorBefore.text(strBefore);
						cursorAfter.text(strAfter);
						beforWidth = cursorBefore.outerWidth();
						afterWidth = cursorAfter.outerWidth();
						showWidth = beforWidth
								+ parseInt(moveDiv.css("left")
										.replace("px", "")) + cursorWidth;

						if (showWidth < 0) {
							// alert("ok");
							var left = parseInt(moveDiv.css("left").replace(
									"px", ""))
									+ afterWidth - beforeMoveSize;

							moveDiv.css("left", left);

						}
					}
					break;
				}
				case KEY_YELLOW: {
					if (isSelectLang) {
						return false;
					}
					if (afterWord.length > 0) {
						cursorIndex++;
						beforeMoveSize = cursorBefore.outerWidth();
						var strBefore = beforeWord + afterWord.substring(0, 1);
						var strAfter = afterWord.substring(1, afterWord.length);
						// console.log("strBefore:" + strBefore + "
						// strAfter:" + strAfter);
						beforeWord = strBefore;
						afterWord = strAfter;
						cursorBefore.text(strBefore);
						cursorAfter.text(strAfter);
						beforWidth = cursorBefore.outerWidth();
						afterWidth = cursorAfter.outerWidth();

						showWidth = windowWidth
								- (beforWidth + parseInt(moveDiv.css("left")
										.replace("px", ""))) - cursorWidth;

						if (showWidth < 0) {
							var left = parseInt(moveDiv.css("left").replace(
									"px", ""))
									- (beforWidth - beforeMoveSize);

							moveDiv.css("left", left);

						}
					}
					break;
				}
				case KEY_BLUE: {
					if (isSelectLang) {
						return false;
					}
					isSquareKeyboard = !isSquareKeyboard;
					$this.removeClass('focused');
					softkeyboardHandler.normalKeyInit();
					localStorage.isSquareKeyboard = isSquareKeyboard;
					break;

				}
				case KEY_EXIT: {

					break;
				}
				case KEY_WHITE:
				case KEY_F11: {
					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					cursorBefore.html("");
					cursorAfter.html("");
					wordLength = 0;
					opera.sendPlatformMessage("key://" + "enter");
					wordLength = 0;
					break;
				}
				case KEY_TV: {
					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					$this = $squareKey.find(".keycaps");
					$this.addClass('focused');
					capslock = !capslock;
					softkeyboardHandler.squareKeyCaps();

					localStorage.capslock = capslock;

					break;
				}
				case KEY_RECALL: {
					if (isSelectLang) {
						return false;
					}
					$this.removeClass('focused');
					$this = $squareKey.find(".keydel");
					$this.addClass('focused');
					softkeyboardHandler.deleteCharacters();

					break;
				}

				case KEY_KONG: {
					if (isSelectLang) {
						return false;
					}

					softkeyboardHandler.insertCharacters(" ");

					break;
				}
				default: {
					if (isSelectLang) {
						return false;
					}
					var character = String.fromCharCode(code);
					$this.removeClass('focused');
					softkeyboardHandler.squareKeyPress(character);

					break;
				}
				}

			}, softkeyboardHandler.Language = function(text) {
				switch (text) {
				case "eng": {
					redBtnDiv.text("Confirm");
					greenBtnDiv.text("Prev");
					yellowBtnDiv.text("Next");
					whiteBtnDiv.text("Cancel");
					blueBtnDiv.text("Switch");
					return "English";
					break;
				}
				case "ger": {
					redBtnDiv.text("Bestätigen");
					greenBtnDiv.text("Vorig");
					yellowBtnDiv.text("Neben");
					whiteBtnDiv.text("Lösen");
					blueBtnDiv.text("Schalten");
					return "Deutsch";
					break;
				}
				case "rus": {
					redBtnDiv.text("конфирмовать");
					greenBtnDiv.text("предыдущий");
					yellowBtnDiv.text("рядом");
					whiteBtnDiv.text("отменять");
					blueBtnDiv.text("свитч");
					return "Pусский";
					break;
				}
				case "tur": {
					redBtnDiv.text("şalter");
					greenBtnDiv.text("önceki");
					yellowBtnDiv.text("Sonraki");
					whiteBtnDiv.text("Iptal");
					blueBtnDiv.text("Dönüşme");
					return "Türk";
					break;
				}
				case "hun": {
					redBtnDiv.text("Konfirmál");
					greenBtnDiv.text("Előző");
					yellowBtnDiv.text("Mellett");
					whiteBtnDiv.text("Sztorníroz");
					blueBtnDiv.text("Kapcsol");

					return "Magyar";
					break;
				}
				case "ara": {
					redBtnDiv.text("تأكيد");
					greenBtnDiv.text("سابق");
					yellowBtnDiv.text("التالي");
					whiteBtnDiv.text("إلغاء");
					blueBtnDiv.text("تحول");
					$whiteKey.hide();
					return "العربية";
					break;
				}
				case "heb": {
					redBtnDiv.text("לאשר");
					greenBtnDiv.text("קודם");
					yellowBtnDiv.text("הבא");
					whiteBtnDiv.text("לבטל");
					blueBtnDiv.text("מתג");
					$whiteKey.hide();
					return "עברית";
					break;
				}
				}

			}, softkeyboardHandler.ChanageAraClass = function() {

				if (lang == "ara") {
					jQuery(".normalKeyboard .ara .key12 span[class='true']")
							.html("\u064e");
					jQuery(".normalKeyboard .ara .key13 span[class='true']")
							.html("\u064b");
					jQuery(".normalKeyboard .ara .key14 span[class='true']")
							.html("\u064f");
					jQuery(".normalKeyboard .ara .key15 span[class='true']")
							.html("\u064c");
					jQuery(".normalKeyboard .ara .key19 span[class='true']")
							.html("\u00f7");
					jQuery(".normalKeyboard .ara .key21 span[class='true']")
							.html("\u0650");
					jQuery(".normalKeyboard .ara .key213 span[class='true']")
							.html("\u0652");
					cursorAfter.css("direction", " rtl");
					cursorBefore.css("direction", " rtl");
				} else if (lang == "heb") {
					cursorAfter.css("direction", " rtl");
					cursorBefore.css("direction", " rtl");
				} else {
					cursorAfter.css("direction", " ltr");
					cursorBefore.css("direction", "ltr");
				}

			}
})();
String.prototype.Trim = function() {
	return this.replace(/(^\s*)|(\s*$)/g, "");
}
